CREATE DATABASE  IF NOT EXISTS `mydb` /*!40100 DEFAULT CHARACTER SET latin1 */;
USE `mydb`;
-- MySQL dump 10.13  Distrib 5.1.40, for Win32 (ia32)
--
-- Host: projetopoo.no-ip.org    Database: mydb
-- ------------------------------------------------------
-- Server version	5.1.52-community-log

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `notas`
--

DROP TABLE IF EXISTS `notas`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `notas` (
  `noID` int(11) NOT NULL AUTO_INCREMENT,
  `noConceito` varchar(1) NOT NULL,
  `noMatricula` int(11) NOT NULL,
  PRIMARY KEY (`noID`),
  KEY `no_ma` (`noMatricula`)
) ENGINE=MyISAM AUTO_INCREMENT=24 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `notas`
--

LOCK TABLES `notas` WRITE;
/*!40000 ALTER TABLE `notas` DISABLE KEYS */;
INSERT INTO `notas` VALUES (1,'A',1),(2,'A',10),(12,'A',2),(9,'A',1),(10,'A',1),(11,'B',10),(13,'A',11),(14,'A',15),(15,'A',21),(16,'A',27),(17,'A',33),(18,'A',1),(19,'A',10),(20,'A',14),(21,'A',20),(22,'A',26),(23,'A',32);
/*!40000 ALTER TABLE `notas` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `turma`
--

DROP TABLE IF EXISTS `turma`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `turma` (
  `tuID` int(11) NOT NULL AUTO_INCREMENT,
  `tuDisciplina` int(11) NOT NULL,
  `tuProfessor` int(11) NOT NULL,
  PRIMARY KEY (`tuID`),
  KEY `tu_di` (`tuDisciplina`),
  KEY `tu_pr` (`tuProfessor`)
) ENGINE=MyISAM AUTO_INCREMENT=11 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `turma`
--

LOCK TABLES `turma` WRITE;
/*!40000 ALTER TABLE `turma` DISABLE KEYS */;
INSERT INTO `turma` VALUES (1,1,1),(2,3,2),(5,2,2),(6,5,12),(7,4,9),(8,4,9),(9,6,19),(10,7,20);
/*!40000 ALTER TABLE `turma` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `matriculas`
--

DROP TABLE IF EXISTS `matriculas`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `matriculas` (
  `maID` int(11) NOT NULL AUTO_INCREMENT,
  `maTurma` int(11) NOT NULL,
  `maAluno` int(11) NOT NULL,
  PRIMARY KEY (`maID`),
  KEY `ma_tu` (`maTurma`),
  KEY `ma_al` (`maAluno`)
) ENGINE=MyISAM AUTO_INCREMENT=39 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `matriculas`
--

LOCK TABLES `matriculas` WRITE;
/*!40000 ALTER TABLE `matriculas` DISABLE KEYS */;
INSERT INTO `matriculas` VALUES (1,1,2),(2,5,2),(4,0,1),(5,0,2),(6,0,2),(7,0,2),(8,0,2),(9,0,1),(10,1,1),(11,5,1),(12,7,1),(13,9,1),(14,1,4),(15,5,4),(16,2,4),(17,7,4),(18,6,4),(19,9,4),(20,1,5),(21,5,5),(22,2,5),(23,7,5),(24,6,5),(25,9,5),(26,1,6),(27,5,6),(28,2,6),(29,7,6),(30,6,6),(31,9,6),(32,1,7),(33,5,7),(34,2,7),(35,7,7),(36,6,7),(37,9,7),(38,10,16);
/*!40000 ALTER TABLE `matriculas` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `administrador`
--

DROP TABLE IF EXISTS `administrador`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `administrador` (
  `adID` int(11) NOT NULL AUTO_INCREMENT,
  `adNome` varchar(45) NOT NULL,
  `adSenha` varchar(45) NOT NULL,
  `adLogin` varchar(45) NOT NULL,
  PRIMARY KEY (`adID`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `administrador`
--

LOCK TABLES `administrador` WRITE;
/*!40000 ALTER TABLE `administrador` DISABLE KEYS */;
INSERT INTO `administrador` VALUES (1,'Glaucio Bertelli Peres','123456','glaucio'),(2,'Zilmar de Suoza Junior','123456','zilmar'),(3,'Administrador','123456','admin');
/*!40000 ALTER TABLE `administrador` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `disciplinas`
--

DROP TABLE IF EXISTS `disciplinas`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `disciplinas` (
  `diID` int(11) NOT NULL AUTO_INCREMENT,
  `diNome` varchar(45) NOT NULL,
  `diCreditos` int(11) NOT NULL,
  PRIMARY KEY (`diID`)
) ENGINE=MyISAM AUTO_INCREMENT=8 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `disciplinas`
--

LOCK TABLES `disciplinas` WRITE;
/*!40000 ALTER TABLE `disciplinas` DISABLE KEYS */;
INSERT INTO `disciplinas` VALUES (1,'Programação Orientada à Objetos',4),(2,'Sinais e Sistemas 2',4),(3,'Sinais e Sistemas 1',4),(4,'Redes de Computadores 3',4),(5,'Redes de Computadores 2',6),(6,'Ingles 1',2),(7,'DPOO',3);
/*!40000 ALTER TABLE `disciplinas` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `frequencia`
--

DROP TABLE IF EXISTS `frequencia`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `frequencia` (
  `frID` int(11) NOT NULL AUTO_INCREMENT,
  `frMatricula` int(11) NOT NULL,
  `frFalta` int(11) NOT NULL,
  `frData` date NOT NULL,
  PRIMARY KEY (`frID`),
  KEY `fr_ma` (`frFalta`)
) ENGINE=MyISAM AUTO_INCREMENT=24 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `frequencia`
--

LOCK TABLES `frequencia` WRITE;
/*!40000 ALTER TABLE `frequencia` DISABLE KEYS */;
INSERT INTO `frequencia` VALUES (1,1,1,'2010-12-02'),(2,10,1,'2010-12-02'),(3,1,3,'2010-12-07'),(4,10,0,'2010-12-07'),(5,1,3,'2010-12-09'),(6,10,0,'2010-12-09'),(7,1,3,'2010-12-04'),(8,10,3,'2010-12-04'),(9,2,0,'2010-12-08'),(10,11,0,'2010-12-08'),(11,2,0,'2010-12-09'),(12,11,0,'2010-12-09'),(13,15,0,'2010-12-09'),(14,21,0,'2010-12-09'),(15,27,0,'2010-12-09'),(16,33,0,'2010-12-09'),(17,1,0,'2010-12-13'),(18,10,0,'2010-12-13'),(19,14,1,'2010-12-13'),(20,20,2,'2010-12-13'),(21,26,0,'2010-12-13'),(22,32,3,'2010-12-13'),(23,38,3,'2010-12-16');
/*!40000 ALTER TABLE `frequencia` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `aluno`
--

DROP TABLE IF EXISTS `aluno`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `aluno` (
  `alID` int(11) NOT NULL AUTO_INCREMENT,
  `alNome` varchar(45) NOT NULL,
  `alMatricula` int(11) NOT NULL,
  PRIMARY KEY (`alID`)
) ENGINE=MyISAM AUTO_INCREMENT=17 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `aluno`
--

LOCK TABLES `aluno` WRITE;
/*!40000 ALTER TABLE `aluno` DISABLE KEYS */;
INSERT INTO `aluno` VALUES (1,'Zilmar de Souza Junior',822070146),(2,'Glaucio Bertelli Peres',822070065),(3,'Thayse Christine da Silva',912070111),(4,'Jones William Martins',822070333),(5,'Eduardo Mello Garcia',822070112),(6,'Lucas Ghizoni',822070134),(7,'Maicon Costa',822702701),(8,'Crhistiane Dias de Azevedo',821214562),(9,'Felipe Mariano',450749583),(10,'Guilherme Bilbao Soares da Silva',824656473),(11,'Paulo Alves',743563728),(12,'Rafael Togo',974564713),(13,'Sant\'Clear Ali Costa ',612837412),(14,'Regiane Paiter',746471824),(15,'Jackson Luiz Silva',816237128),(16,'João',123456788);
/*!40000 ALTER TABLE `aluno` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `professores`
--

DROP TABLE IF EXISTS `professores`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `professores` (
  `prID` int(11) NOT NULL AUTO_INCREMENT,
  `prNome` varchar(45) NOT NULL,
  `prSenha` varchar(45) NOT NULL,
  `prLogin` varchar(45) NOT NULL,
  PRIMARY KEY (`prID`)
) ENGINE=MyISAM AUTO_INCREMENT=21 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `professores`
--

LOCK TABLES `professores` WRITE;
/*!40000 ALTER TABLE `professores` DISABLE KEYS */;
INSERT INTO `professores` VALUES (1,'Emerson de Mello','123456','emerson'),(2,'Marcos Moecke','123456','marcos'),(3,'Evandro Cantú','123456','evando'),(4,'Alexandre Moreira','123456','alexandre'),(5,'André Luis Alves','123456','andre'),(6,'Jaci Destri','123456','jaci'),(7,'Pedro Paulo Corrêa de Souza','123456','pedropaulo'),(8,'Ederson Torresini','123456','ederson'),(9,'Eraldo Silveira e Silava','123456','eraldo'),(10,'Fabio Alexandre de Souza','123456','fabio'),(11,'Jorge Henrique Busatto Casagrande','123456','jorgehenrique'),(12,'Marcelo Maia Sobral','123456','marcelo'),(13,'Marcio Henrique Doniak','123456','marcio'),(14,'Maria Claudia de Almeida Castro','123456','claudia'),(15,'Nilton Francisco Oliveira da Silva','123456','nilton'),(19,'Viviane','123456','viviane'),(17,'Odilson Tadeu Valle','123456','odilson'),(18,'Rubem Toledo Bergamo','123456','rubem'),(20,'P. João','123','pjoao');
/*!40000 ALTER TABLE `professores` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2010-12-16 10:31:09
