/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * CadastroAlunos.java
 *
 * Created on 21/11/2010, 23:06:18
 */
package interfaces;

import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.sql.Connection;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.table.DefaultTableModel;
import util.bd.Alunos;
import util.bd.ConexaoBD;

/**
 *
 * @author Junior
 */
public class CadastroAlunos extends javax.swing.JFrame {

    private Connection conexao;

    public CadastroAlunos(java.awt.Frame parent, boolean modal) {
        initComponents();
        this.setLocationRelativeTo(parent);
        //conexao = new ConexaoBD().obterConexao();
    }

    public void cadastroAluno(String nome, Long matricula) throws SQLException {
        conexao = new ConexaoBD().obterConexao();
        String sql = "INSERT INTO aluno (alNome,alMatricula) VALUES (?,?)";
        try {
            PreparedStatement st = conexao.prepareStatement(sql);
            // preenchendo as ? na instrucao SQL
            st.setString(1, nome);
            st.setLong(2, matricula);
            // executando
            st.execute();
            // fechando a instrucao
            st.close();
            System.out.println("Inserido com sucesso");
        } catch (SQLException ex) {
            System.err.println("Erro ao inserir: " + ex.toString());
        }
        conexao.close();
    }

    public void adicionarNaTabela(ArrayList<Alunos> al) {
        DefaultTableModel modelo = (DefaultTableModel) jTableLista.getModel();
        // percorrendo a lista de contatos
        for (Alunos alunos : al) {
            String vetor[] = new String[4];
            vetor[0] = Long.toString(alunos.getId());
            vetor[1] = alunos.getNome();
            vetor[2] = Long.toString(alunos.getMatricula());
            //adicionando na tabela
            modelo.addRow(vetor);
        }
    }

    public ArrayList<Alunos> listagemParaTabela() throws SQLException {
        conexao = new ConexaoBD().obterConexao();
        ArrayList<Alunos> lista = new ArrayList<Alunos>();
        String sql = "SELECT * FROM aluno";
        try {
            PreparedStatement instrucao = conexao.prepareStatement(sql);
            // executando a instrução
            ResultSet rs = instrucao.executeQuery();
            // percorrendo a lista obtida do banco
            while (rs.next()) {
                Alunos pessoa = new Alunos();
                pessoa.setId(new Long(rs.getInt("alID")));
                pessoa.setNome(rs.getString("alNome"));
                pessoa.setMatricula(new Long(rs.getInt("alMatricula")));
                // adicionando no ArrayList
                lista.add(pessoa);
            }
            // fechando
            instrucao.close();
        } catch (SQLException ex) {
            System.err.println("Erro ao inserir: " + ex.toString());
        }
        conexao.close();
        return lista;

    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTFNome = new javax.swing.JTextField();
        Nome = new javax.swing.JLabel();
        jBListar = new javax.swing.JButton();
        jBConcluido = new javax.swing.JButton();
        jLLogin = new javax.swing.JLabel();
        jBAdicionar = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTableLista = new javax.swing.JTable();
        jTFMatricula = new javax.swing.JFormattedTextField();

        jTFNome.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTFNomeActionPerformed(evt);
            }
        });

        Nome.setText("Nome");

        jBListar.setText("Listar");
        jBListar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBListarActionPerformed(evt);
            }
        });

        jBConcluido.setText("Concluído");
        jBConcluido.setEnabled(false);
        jBConcluido.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBConcluidoActionPerformed(evt);
            }
        });

        jLLogin.setText("Matricula");

        jBAdicionar.setText("Adicionar");
        jBAdicionar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBAdicionarActionPerformed(evt);
            }
        });

        jTableLista.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "iD", "Nome", "Matricula"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.Long.class, java.lang.String.class, java.lang.Integer.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane1.setViewportView(jTableLista);

        try {
            jTFMatricula.setFormatterFactory(new javax.swing.text.DefaultFormatterFactory(new javax.swing.text.MaskFormatter("##########")));
        } catch (java.text.ParseException ex) {
            ex.printStackTrace();
        }
        jTFMatricula.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jTFMatricula.setCursor(new java.awt.Cursor(java.awt.Cursor.TEXT_CURSOR));
        jTFMatricula.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTFMatriculaActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jScrollPane1, 0, 0, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLLogin)
                            .addComponent(Nome))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jTFNome, javax.swing.GroupLayout.PREFERRED_SIZE, 293, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addComponent(jBConcluido)
                                    .addComponent(jTFMatricula, javax.swing.GroupLayout.PREFERRED_SIZE, 156, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(jBListar))))
                    .addComponent(jBAdicionar))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jBAdicionar, jBConcluido, jBListar});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(Nome)
                    .addComponent(jTFNome, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(9, 9, 9)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLLogin)
                    .addComponent(jTFMatricula, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jBAdicionar)
                    .addComponent(jBConcluido)
                    .addComponent(jBListar))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 180, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(25, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jTFNomeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTFNomeActionPerformed
        // TODO add your handling code here:
}//GEN-LAST:event_jTFNomeActionPerformed

    private void jBListarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBListarActionPerformed
        DefaultTableModel modelo = (DefaultTableModel) jTableLista.getModel();
        while (modelo.getRowCount() > 0) {
            modelo.removeRow(0);
        }

        ArrayList<Alunos> al = null;
        try {
            al = this.listagemParaTabela();
        } catch (SQLException ex) {
            System.err.println("Erro ao inserir: " + ex.toString());
        }
        adicionarNaTabela(al);

    }//GEN-LAST:event_jBListarActionPerformed

    private void jBConcluidoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBConcluidoActionPerformed
        // TODO add your handling code here:
        jBConcluido.setEnabled(false);
        jBAdicionar.setEnabled(true);
        String nome = jTFNome.getText();
        Long matricula = Long.parseLong(jTFMatricula.getText());
        try {
            this.cadastroAluno(nome, matricula);
        } catch (SQLException ex) {
            Logger.getLogger(CadastroAlunos.class.getName()).log(Level.SEVERE, null, ex);
        }
        jTFNome.setEnabled(false);
        jTFMatricula.setEnabled(false);

    }//GEN-LAST:event_jBConcluidoActionPerformed

    private void jBAdicionarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBAdicionarActionPerformed
        jBConcluido.setEnabled(true);
        jBAdicionar.setEnabled(false);
        jTFNome.setText("");
        jTFMatricula.setText("");
        jTFNome.setEnabled(true);
        jTFMatricula.setEnabled(true);


    }//GEN-LAST:event_jBAdicionarActionPerformed

    private void jTFMatriculaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTFMatriculaActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jTFMatriculaActionPerformed
    /**
     * @param args the command line arguments
     */
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel Nome;
    private javax.swing.JButton jBAdicionar;
    private javax.swing.JButton jBConcluido;
    private javax.swing.JButton jBListar;
    private javax.swing.JLabel jLLogin;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JFormattedTextField jTFMatricula;
    private javax.swing.JTextField jTFNome;
    private javax.swing.JTable jTableLista;
    // End of variables declaration//GEN-END:variables
}
