package interfaces;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import javax.swing.DefaultCellEditor;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumn;
import util.bd.Conceitos;
import util.bd.ConexaoBD;
import javax.swing.JComboBox;

public class CadastroConceitos extends javax.swing.JFrame {

    private String disciplina;
    private Connection conexao;
    private String idTurma;
    private String idMatricula;

    public CadastroConceitos(java.awt.Frame parent, boolean modal, String disciplina) {
        initComponents();
        this.setLocationRelativeTo(parent);
        this.disciplina = disciplina;
        jLTurma.setText("Turma " + this.disciplina);
        gerarConc();
        popularAlunos();
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLTurma = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTableLista = new javax.swing.JTable();
        jBOk = new javax.swing.JButton();
        jBLimpar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jLTurma.setText("Turma");

        jTableLista.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Aluno", "Conceito"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.Object.class
            };
            boolean[] canEdit = new boolean [] {
                false, true
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane1.setViewportView(jTableLista);

        jBOk.setText("OK");
        jBOk.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBOkActionPerformed(evt);
            }
        });

        jBLimpar.setText("Limpar");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 693, Short.MAX_VALUE)
                            .addComponent(jLTurma))
                        .addContainerGap())
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(jBOk)
                        .addGap(18, 18, 18)
                        .addComponent(jBLimpar)
                        .addGap(24, 24, 24))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLTurma)
                .addGap(18, 18, 18)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 404, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jBOk)
                    .addComponent(jBLimpar))
                .addContainerGap(27, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jBOkActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBOkActionPerformed
        conexao = new ConexaoBD().obterConexao();
        String sql = "select ma.maID from matriculas ma, aluno al "
                + "where maTurma = ? and al.alNome = ? and ma.maAluno = al.alID";
        DefaultTableModel tabela = (DefaultTableModel) jTableLista.getModel();
        int a = tabela.getRowCount();
        System.out.println("" + a);
        String aluno[] = new String[a];
        String conceito[] = new String[a];

        try {
            for (int i = 0; i < a; i++) {
                aluno[i] = (String) tabela.getValueAt(i, 0);
                conceito[i] = (String) tabela.getValueAt(i, 1);
                PreparedStatement st = conexao.prepareStatement(sql);
                // preenchendo as ? na instrucao SQL
                st.setString(1, this.idTurma);
                st.setString(2, aluno[i]);
                // executando
                ResultSet rs = st.executeQuery();
                rs.next();
                this.idMatricula = rs.getString("maID");
                rs.close();
                st.close();
                String sql1 = "INSERT INTO notas (noConceito, noMatricula) values (?, ?)";
                PreparedStatement st1 = conexao.prepareStatement(sql1);
                // preenchendo as ? na instrucao SQL
                st1.setString(1, conceito[i]);
                st1.setString(2, this.idMatricula);
                // executando
                st1.execute();
                st1.close();
            }
        } catch (SQLException ex) {
            System.err.println("Erro: " + ex.toString());

        }
    }//GEN-LAST:event_jBOkActionPerformed

    private void popularAlunos() {
        conexao = new ConexaoBD().obterConexao();
        String sql1 = "select tu.tuID from turma tu, disciplinas di where "
                + "tu.tuDisciplina = di.diID and di.diNome = ?";
        try {
            PreparedStatement st = conexao.prepareStatement(sql1);
            // preenchendo as ? na instrucao SQL
            st.setString(1, this.disciplina);
            // executando
            ResultSet rs = st.executeQuery();
            rs.next();
            this.idTurma = rs.getString("tuID");
            rs.close();
            st.close();
            ArrayList<Conceitos> a = listagemParaTabela();
            adicionarNaTabela(a);
        } catch (SQLException ex) {
            System.err.println("Erro: " + ex.toString());
        }

    }

    private ArrayList<Conceitos> listagemParaTabela() {
        String sql = "select ma.maAluno, al.alNome from matriculas ma, aluno al "
                + "where ma.maTurma = ? and al.alID = ma.maAluno";
        conexao = new ConexaoBD().obterConexao();
        ArrayList<Conceitos> lista = new ArrayList<Conceitos>();

        try {
            PreparedStatement st = conexao.prepareStatement(sql);
            // preenchendo as ? na instrucao SQL
            st.setString(1, this.idTurma);
            // executando
            ResultSet rs = st.executeQuery();
            // percorrendo a lista obtida do banco
            while (rs.next()) {
                Conceitos conceito = new Conceitos();
                conceito.setAluno(rs.getString("alNome"));
                // adicionando no ArrayList
                lista.add(conceito);
            }
            // fechando
            rs.close();
        } catch (SQLException ex) {
            System.err.println("Erro na listagem de contatos: " + ex.toString());
        }
        return lista;
    }

    private void adicionarNaTabela(ArrayList<Conceitos> co) {
        DefaultTableModel modelo = (DefaultTableModel) jTableLista.getModel();
        // percorrendo a lista de contatos
        for (Conceitos conceito : co) {
            String vetor[] = new String[1];
            vetor[0] = conceito.getAluno();
            //adicionando na tabela
            modelo.addRow(vetor);
        }

    }

    private void gerarConc() {
        TableColumn colunaFreq = jTableLista.getColumnModel().getColumn(1);
        JComboBox comboBox = new JComboBox();
        comboBox.removeAllItems();
        comboBox.addItem("A");
        comboBox.addItem("B");
        comboBox.addItem("C");
        comboBox.addItem("D");
        comboBox.setSelectedIndex(1);
        colunaFreq.setCellEditor(new DefaultCellEditor(comboBox));
    }
    /**
     * @param args the command line arguments
     */
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jBLimpar;
    private javax.swing.JButton jBOk;
    private javax.swing.JLabel jLTurma;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTableLista;
    // End of variables declaration//GEN-END:variables
}
