package interfaces;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import javax.swing.table.DefaultTableModel;
import util.bd.ConexaoBD;
import util.bd.Disciplina;

public class CadastroDisciplina extends javax.swing.JFrame {

    private Connection conexao;

    /** Creates new form CadastroDisciplina */
    public CadastroDisciplina(java.awt.Frame parent, boolean modal) {
        initComponents();
        this.setLocationRelativeTo(parent);
        conexao = new ConexaoBD().obterConexao();
        jTFDisciplina.setEnabled(false);
        jTFCreditos.setEnabled(false);
        jBconcluido.setEnabled(false);
    }

    public void cadastroDisciplina(String disciplina, int creditos) {

        String sql = "insert into disciplinas (diNome, diCreditos) values (?, ?)";
        try {
            PreparedStatement st = conexao.prepareStatement(sql);
            // preenchendo as ? na instrucao SQL
            st.setString(1, disciplina);
            st.setInt(2, creditos);
            // executando
            st.execute();
            // fechando a instrucao
            st.close();
            System.out.println("Inserido com sucesso");
        } catch (SQLException ex) {
            System.err.println("Erro ao inserir: " + ex.toString());
        }
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jTFDisciplina = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        jBAdicionar = new javax.swing.JButton();
        jBconcluido = new javax.swing.JButton();
        jBListar = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTableLista = new javax.swing.JTable();
        jTFCreditos = new javax.swing.JTextField();

        jLabel1.setText("Digite o nome da disciplina:");

        jTFDisciplina.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTFDisciplinaActionPerformed(evt);
            }
        });

        jLabel2.setText("Digite os créditos desta disciplina:");

        jBAdicionar.setText("Adicionar");
        jBAdicionar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBAdicionarActionPerformed(evt);
            }
        });

        jBconcluido.setText("Concluído");
        jBconcluido.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBconcluidoActionPerformed(evt);
            }
        });

        jBListar.setText("Listar");
        jBListar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBListarActionPerformed(evt);
            }
        });

        jTableLista.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null},
                {null, null},
                {null, null},
                {null, null}
            },
            new String [] {
                "Disciplina", "Créditos"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.Integer.class
            };
            boolean[] canEdit = new boolean [] {
                false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane1.setViewportView(jTableLista);

        jTFCreditos.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTFCreditosActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 375, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(jTFCreditos, javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel1, javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jTFDisciplina, javax.swing.GroupLayout.Alignment.LEADING))
                        .addGap(50, 50, 50)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jBListar)
                            .addComponent(jBconcluido)
                            .addComponent(jBAdicionar))))
                .addContainerGap(15, Short.MAX_VALUE))
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jBAdicionar, jBListar, jBconcluido});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jBAdicionar))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTFDisciplina, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jBconcluido))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jBListar)
                    .addComponent(jLabel2))
                .addGap(4, 4, 4)
                .addComponent(jTFCreditos, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 110, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jBconcluidoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBconcluidoActionPerformed

        String disciplina = jTFDisciplina.getText();
        int creditos = Integer.parseInt(jTFCreditos.getText());
        jTFDisciplina.setText("");
        jTFCreditos.setText("");
        jBAdicionar.setEnabled(true);
        jTFDisciplina.setEnabled(false);
        jTFCreditos.setEnabled(false);
        jBconcluido.setEnabled(false);
        this.cadastroDisciplina(disciplina, creditos);

    }//GEN-LAST:event_jBconcluidoActionPerformed

    private void jTFDisciplinaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTFDisciplinaActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jTFDisciplinaActionPerformed

    private void jBAdicionarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBAdicionarActionPerformed
        jBAdicionar.setEnabled(false);
        jTFDisciplina.setEnabled(true);
        jTFCreditos.setEnabled(true);
        jBconcluido.setEnabled(true);

    }//GEN-LAST:event_jBAdicionarActionPerformed

    private void jBListarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBListarActionPerformed
        DefaultTableModel modelo = (DefaultTableModel) jTableLista.getModel();
        while (modelo.getRowCount() > 0) {
            modelo.removeRow(0);
        }

        ArrayList<Disciplina> al = this.listagemParaTabela();
        adicionarNaTabela(al);
    }//GEN-LAST:event_jBListarActionPerformed

    private void jTFCreditosActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTFCreditosActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jTFCreditosActionPerformed

    public void adicionarNaTabela(ArrayList<Disciplina> al) {
        DefaultTableModel modelo = (DefaultTableModel) jTableLista.getModel();
        // percorrendo a lista de contatos
        for (Disciplina disciplina : al) {
            String vetor[] = new String[2];
            vetor[0] = disciplina.getNome();
            vetor[1] = Long.toString(disciplina.getCreditos());

            //adicionando na tabela
            modelo.addRow(vetor);
        }
    }

    public ArrayList<Disciplina> listagemParaTabela() {
        ArrayList<Disciplina> lista = new ArrayList<Disciplina>();
        String sql = "select diNome, diCreditos from disciplinas";
        try {
            PreparedStatement instrucao = conexao.prepareStatement(sql);
            // executando a instrução
            ResultSet rs = instrucao.executeQuery();
            // percorrendo a lista obtida do banco

            while (rs.next()) {
                Disciplina materia = new Disciplina();
                materia.setCreditos(rs.getInt("diCreditos"));
                materia.setNome(rs.getString("diNome"));

                // adicionando no ArrayList
                lista.add(materia);
            }
            // fechando
            instrucao.close();
        } catch (SQLException ex) {
            System.err.println("Erro na listagem de contatos: " + ex.toString());
        }
        return lista;
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jBAdicionar;
    private javax.swing.JButton jBListar;
    private javax.swing.JButton jBconcluido;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextField jTFCreditos;
    private javax.swing.JTextField jTFDisciplina;
    private javax.swing.JTable jTableLista;
    // End of variables declaration//GEN-END:variables
}
