package interfaces;

import java.sql.Connection;
import java.util.Date;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import javax.swing.DefaultCellEditor;
import javax.swing.JComboBox;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumn;
import util.bd.ConexaoBD;
import util.bd.Frequencia;

public class CadastroFrequencia extends javax.swing.JFrame {

    private String disciplina;
    private Connection conexao;
    private String idTurma, idMatricula;
    private Date date;

    /** Creates new form CadastroFrequencia */
    public CadastroFrequencia(java.awt.Frame parent, boolean modal, String disciplina, Date date) {
        initComponents();
        this.setLocationRelativeTo(parent);
        this.disciplina = disciplina;
        this.date = date;
        jLTurma.setText("Turma " + this.disciplina);
        gerarFreq();
        popularAlunos();
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTableLista = new javax.swing.JTable();
        jLTurma = new javax.swing.JLabel();
        jBOk = new javax.swing.JButton();
        jBLimpar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jTableLista.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Aluno", "Falta(s)"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, true
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane1.setViewportView(jTableLista);
        jTableLista.getColumnModel().getColumn(1).setCellEditor(jTableLista.getCellEditor());

        jLTurma.setText("Turma");

        jBOk.setText("Ok");
        jBOk.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBOkActionPerformed(evt);
            }
        });

        jBLimpar.setText("Limpar");
        jBLimpar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBLimparActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jLTurma)
                    .addGroup(layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 33, Short.MAX_VALUE)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jBOk, javax.swing.GroupLayout.PREFERRED_SIZE, 96, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18)
                                .addComponent(jBLimpar, javax.swing.GroupLayout.PREFERRED_SIZE, 63, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 632, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addGap(38, 38, 38))
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jBLimpar, jBOk});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLTurma)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jBLimpar)
                    .addComponent(jBOk))
                .addContainerGap(12, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jBLimparActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBLimparActionPerformed
        DefaultTableModel tabela = (DefaultTableModel) jTableLista.getModel();
        int a = tabela.getRowCount();
        for (int i = 0; i < a; i++) {
            tabela.setValueAt(null, i, 1);
        }

    }//GEN-LAST:event_jBLimparActionPerformed

    private void jBOkActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBOkActionPerformed
        conexao = new ConexaoBD().obterConexao();
        String sql = "select ma.maID from matriculas ma, aluno al "
                + "where maTurma = ? and al.alNome = ? and ma.maAluno = al.alID";
        DefaultTableModel tabela = (DefaultTableModel) jTableLista.getModel();
        int a = tabela.getRowCount();
        System.out.println("" + a);
        String aluno[] = new String[a];
        int frequencia[] = new int[a];

        try {
            for (int i = 0; i < a; i++) {
                aluno[i] = (String) tabela.getValueAt(i, 0);
                frequencia[i] = Integer.parseInt((String) tabela.getValueAt(i, 1));
                PreparedStatement st = conexao.prepareStatement(sql);
                // preenchendo as ? na instrucao SQL
                st.setString(1, this.idTurma);
                st.setString(2, aluno[i]);
                // executando
                ResultSet rs = st.executeQuery();
                rs.next();
                this.idMatricula = rs.getString("maID");
                rs.close();
                st.close();
                String sql1 = "INSERT INTO frequencia (frMatricula, frFalta, frData) values (?, ?, ?)";
                PreparedStatement st1 = conexao.prepareStatement(sql1);
                // preenchendo as ? na instrucao SQL
                st1.setString(1, this.idMatricula);
                st1.setInt(2, frequencia[i]);

                st1.setDate(3, new java.sql.Date(date.getTime()));
                // executando
                st1.execute();
                st1.close();
            }
        } catch (SQLException ex) {
            System.err.println("Erro: " + ex.toString());
        }

    }//GEN-LAST:event_jBOkActionPerformed

    private void gerarFreq() {
        TableColumn colunaFreq = jTableLista.getColumnModel().getColumn(1);
        JComboBox comboBox = new JComboBox();
        comboBox.removeAllItems();
        comboBox.addItem("0");
        comboBox.addItem("1");
        comboBox.addItem("2");
        comboBox.addItem("3");
        comboBox.setSelectedIndex(1);
        colunaFreq.setCellEditor(new DefaultCellEditor(comboBox));
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jBLimpar;
    private javax.swing.JButton jBOk;
    private javax.swing.JLabel jLTurma;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTableLista;
    // End of variables declaration//GEN-END:variables

    private void popularAlunos() {
        conexao = new ConexaoBD().obterConexao();
        String sql1 = "select tu.tuID from turma tu, disciplinas di where "
                + "tu.tuDisciplina = di.diID and di.diNome = ?";
        try {
            PreparedStatement st = conexao.prepareStatement(sql1);
            // preenchendo as ? na instrucao SQL
            st.setString(1, this.disciplina);
            // executando
            ResultSet rs = st.executeQuery();
            rs.next();
            this.idTurma = rs.getString("tuID");
            rs.close();
            st.close();
            ArrayList<Frequencia> a = listagemParaTabela();
            adicionarNaTabela(a);
        } catch (SQLException ex) {
            System.err.println("Erro: " + ex.toString());
        }

    }

    private ArrayList<Frequencia> listagemParaTabela() {
        String sql = "select ma.maAluno, al.alNome from matriculas ma, aluno al "
                + "where ma.maTurma = ? and al.alID = ma.maAluno";
        conexao = new ConexaoBD().obterConexao();
        ArrayList<Frequencia> lista = new ArrayList<Frequencia>();

        try {
            PreparedStatement st = conexao.prepareStatement(sql);
            // preenchendo as ? na instrucao SQL
            st.setString(1, this.idTurma);
            // executando
            ResultSet rs = st.executeQuery();
            // percorrendo a lista obtida do banco
            while (rs.next()) {
                Frequencia frequencia = new Frequencia();
                frequencia.setAlunos(rs.getString("alNome"));
                // adicionando no ArrayList
                lista.add(frequencia);
            }
            // fechando
            rs.close();
        } catch (SQLException ex) {
            System.err.println("Erro na listagem de contatos: " + ex.toString());
        }
        return lista;
    }

    private void adicionarNaTabela(ArrayList<Frequencia> fr) {
        DefaultTableModel modelo = (DefaultTableModel) jTableLista.getModel();
        // percorrendo a lista de contatos
        for (Frequencia frequencia : fr) {
            String vetor[] = new String[1];
            vetor[0] = frequencia.getAlunos();
            //adicionando na tabela
            modelo.addRow(vetor);
        }

    }
}
