package interfaces;

import util.bd.Turmas;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import javax.swing.table.DefaultTableModel;
import util.bd.ConexaoBD;

public final class CadastroTurmas extends javax.swing.JFrame {

    private Connection conexao;

    public CadastroTurmas(java.awt.Frame parent, boolean modal) {
        initComponents();
        this.setLocationRelativeTo(parent);
        conexao = new ConexaoBD().obterConexao();
        this.popularDisciplinas();
        this.popularProfessores();
        jBConcluido.setEnabled(false);
        jCBDisciplina.setEnabled(false);
        jCBProfessor.setEnabled(false);


    }

    public void popularDisciplinas() {
        jCBDisciplina.removeAllItems();
        jCBDisciplina.addItem("Selecione uma disciplina.");
        String sql = "SELECT di.diNome FROM disciplinas di";
        try {
            PreparedStatement st = conexao.prepareStatement(sql);
            ResultSet rs = st.executeQuery();

            while (rs.next() == true) {
                String disciplina = rs.getString("diNome");
                jCBDisciplina.addItem(disciplina);

            }
            st.close();
            rs.close();
            System.out.println("Diciplinas populadas com sucesso!");

        } catch (SQLException ex) {
            System.err.println("Erro ao popular disciplinas: " + ex.toString());
        }


    }

    public void popularProfessores() {

        String sql = "SELECT * FROM professores pr";
        jCBProfessor.removeAllItems();
        jCBProfessor.addItem("Selecione um professor.");
        try {
            PreparedStatement st = conexao.prepareStatement(sql);
            ResultSet rs = st.executeQuery();

            while (rs.next() == true) {
                String professor = rs.getString("prNome");
                jCBProfessor.addItem(professor);
            }
            st.close();
            rs.close();
            System.out.println("Professores populados com sucesso.");

        } catch (SQLException ex) {
            System.err.println("Erro ao popular professores: " + ex.toString());
        }
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jCBDisciplina = new javax.swing.JComboBox();
        jCBProfessor = new javax.swing.JComboBox();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTableLista = new javax.swing.JTable();
        jBAdicionar = new javax.swing.JButton();
        jBConcluido = new javax.swing.JButton();
        jBAlterar = new javax.swing.JButton();
        jBListar = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jCBDisciplina.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        jCBDisciplina.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCBDisciplinaActionPerformed(evt);
            }
        });

        jCBProfessor.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        jLabel1.setText("Disciplina:");

        jLabel2.setText("Professor:");

        jTableLista.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null},
                {null, null, null},
                {null, null, null},
                {null, null, null}
            },
            new String [] {
                "ID", "Disciplina", "Professor"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.Integer.class, java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTableLista.getTableHeader().setReorderingAllowed(false);
        jScrollPane1.setViewportView(jTableLista);

        jBAdicionar.setText("Adicionar");
        jBAdicionar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBAdicionarActionPerformed(evt);
            }
        });

        jBConcluido.setText("Concluído");
        jBConcluido.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBConcluidoActionPerformed(evt);
            }
        });

        jBAlterar.setText("Alterar");

        jBListar.setText("Listar");
        jBListar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBListarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 445, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jCBProfessor, 0, 263, Short.MAX_VALUE)
                            .addComponent(jLabel2)
                            .addComponent(jLabel1)
                            .addComponent(jCBDisciplina, 0, 263, Short.MAX_VALUE))
                        .addGap(18, 18, 18)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jBConcluido)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jBListar))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jBAdicionar)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jBAlterar)))))
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jBAdicionar, jBAlterar, jBConcluido, jBListar});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(13, 13, 13)
                .addComponent(jLabel1)
                .addGap(6, 6, 6)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jCBDisciplina, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel2)
                        .addGap(8, 8, 8)
                        .addComponent(jCBProfessor, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jBAdicionar)
                            .addComponent(jBAlterar))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jBConcluido)
                            .addComponent(jBListar))))
                .addGap(59, 59, 59)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 235, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(14, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jBAdicionarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBAdicionarActionPerformed
        jBConcluido.setEnabled(true);
        jCBDisciplina.setEnabled(true);
        jCBProfessor.setEnabled(true);
        jBAdicionar.setEnabled(false);



    }//GEN-LAST:event_jBAdicionarActionPerformed

    private void jBConcluidoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBConcluidoActionPerformed
        jBAdicionar.setEnabled(true);
        jBConcluido.setEnabled(false);
        jCBDisciplina.setEnabled(false);
        jCBProfessor.setEnabled(false);
        String professor = (String) jCBProfessor.getSelectedItem();
        String disciplina = (String) jCBDisciplina.getSelectedItem();
        this.cadastraTurma(professor, disciplina);
    }//GEN-LAST:event_jBConcluidoActionPerformed

    private void jBListarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBListarActionPerformed

        DefaultTableModel modelo = (DefaultTableModel) jTableLista.getModel();
        while (modelo.getRowCount() > 0) {
            modelo.removeRow(0);
        }

        ArrayList<Turmas> al = this.listagemParaTabela();
        adicionarNaTabela(al);


    }//GEN-LAST:event_jBListarActionPerformed

    private void jCBDisciplinaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCBDisciplinaActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jCBDisciplinaActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jBAdicionar;
    private javax.swing.JButton jBAlterar;
    private javax.swing.JButton jBConcluido;
    private javax.swing.JButton jBListar;
    private javax.swing.JComboBox jCBDisciplina;
    private javax.swing.JComboBox jCBProfessor;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTableLista;
    // End of variables declaration//GEN-END:variables

    private void cadastraTurma(String professor, String disciplina) {
        conexao = new ConexaoBD().obterConexao();
        String getProfessor = "SELECT pr.prID FROM professores pr WHERE pr.prNome='" + professor + "'";
        String getDisciplina = "SELECT di.diID FROM disciplinas di WHERE di.diNome='" + disciplina + "'";
        String sql = "INSERT INTO turma (tuDisciplina,tuProfessor) VALUES (?,?)";
        try {
            PreparedStatement getP = conexao.prepareStatement(getProfessor);
            // getP.setString(1, professor);
            ResultSet rs = getP.executeQuery(getProfessor);
            rs.next();
            int tuProfessor = rs.getInt("prID");
            rs.close();
///////////////////////////////////////////////////////////////////////////////
            PreparedStatement getD = conexao.prepareStatement(getDisciplina);
            //   getD.setString(1, disciplina);
            ResultSet rd = getP.executeQuery(getDisciplina);
            rd.next();
            int tuDisciplina = rd.getInt("diID");
            rd.close();
//////////////////////////////////////////////////////////////////////////////
            PreparedStatement st = conexao.prepareStatement(sql);
            // preenchendo as ? na instrucao SQL
            st.setInt(1, tuDisciplina);
            st.setInt(2, tuProfessor);
            // executando
            st.execute();
            // fechando a instrucao
            st.close();
///////////////////////////////////////////////////////////////////////////////
            System.out.println("Turma cadastrada com sucesso.");
        } catch (SQLException ex) {
            System.err.println("Erro ao cadastrar turma: " + ex.toString());
        }
    }

    private ArrayList<Turmas> listagemParaTabela() {
        ArrayList<Turmas> lista = new ArrayList<Turmas>();
        String sql = "SELECT tu.tuID, di.diNome, pr.prNome FROM turma tu, disciplinas di, professores pr WHERE tu.tuDisciplina = di.diID AND tu.tuProfessor = pr.prID";
        try {
            PreparedStatement instrucao = conexao.prepareStatement(sql);
            // executando a instrução
            ResultSet rs = instrucao.executeQuery();
            // percorrendo a lista obtida do banco

            while (rs.next()) {
                Turmas pessoa = new Turmas();
                pessoa.setTuID((rs.getInt("tuID")));
                pessoa.setTuDisciplina(rs.getString("diNome"));
                pessoa.setTuProfessor(rs.getString("prNome"));

                // adicionando no ArrayList
                lista.add(pessoa);
            }
            // fechando
            instrucao.close();
        } catch (SQLException ex) {
            System.err.println("Erro na listagem de contatos: " + ex.toString());
        }
        return lista;
    }

    private void adicionarNaTabela(ArrayList<Turmas> al) {
        DefaultTableModel modelo = (DefaultTableModel) jTableLista.getModel();
        // percorrendo a lista de contatos
        for (Turmas turma : al) {
            String vetor[] = new String[3];
            vetor[0] = Long.toString(turma.getTuID());
            vetor[1] = turma.getTuDisciplina();
            vetor[2] = turma.getTuProfessor();
            //adicionando na tabela
            modelo.addRow(vetor);
        }
    }
}
