package interfaces;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;
import util.bd.ConexaoBD;
import util.bd.Docentes;

public final class ExcluirDocente extends javax.swing.JFrame {

    private Connection conexao;

    public ExcluirDocente(java.awt.Frame parent, boolean modal) {
        initComponents();
        conexao = new ConexaoBD().obterConexao();
        this.popularProfessores();
        this.setLocationRelativeTo(null);
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jCBProfessor = new javax.swing.JComboBox();
        jBExcluir = new javax.swing.JButton();
        jBListar = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTableLista = new javax.swing.JTable();

        jLabel1.setText("Selecione o Professor que deseja excluir:");

        jCBProfessor.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        jCBProfessor.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCBProfessorActionPerformed(evt);
            }
        });

        jBExcluir.setText("Excluir");
        jBExcluir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBExcluirActionPerformed(evt);
            }
        });

        jBListar.setText("Listar");
        jBListar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBListarActionPerformed(evt);
            }
        });

        jTableLista.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null},
                {null, null},
                {null, null},
                {null, null}
            },
            new String [] {
                "ID", "Nome"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.Integer.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane1.setViewportView(jTableLista);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(jCBProfessor, javax.swing.GroupLayout.Alignment.LEADING, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addGap(89, 89, 89)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(jBExcluir, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jBListar, javax.swing.GroupLayout.DEFAULT_SIZE, 89, Short.MAX_VALUE)))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 375, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(15, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jBExcluir)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jBListar))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addGap(18, 18, 18)
                        .addComponent(jCBProfessor, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(38, 38, 38)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 204, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(57, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jCBProfessorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jCBProfessorActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jCBProfessorActionPerformed

    private void jBExcluirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBExcluirActionPerformed
        String nome = (String) jCBProfessor.getSelectedItem();
        String sql = "DELETE FROM professores WHERE prNome = ?";
        try {
            PreparedStatement st = conexao.prepareStatement(sql);

            // preenchendo as ? na instrucao SQL
            st.setString(1, nome);

            // executando
            st.execute();

            // fechando a instrucao
            st.close();
            JOptionPane.showMessageDialog(this, "Professor excluido com sucesso!");


        } catch (SQLException ex) {
            System.err.println("Erro ao inserir1: " + ex.toString());
        }
        this.popularProfessores();
    }//GEN-LAST:event_jBExcluirActionPerformed

    public void popularProfessores() {

        String sql = "SELECT * FROM professores pr";
        jCBProfessor.removeAllItems();
        jCBProfessor.addItem("Selecione um professor.");
        try {
            PreparedStatement st = conexao.prepareStatement(sql);
            ResultSet rs = st.executeQuery();

            while (rs.next() == true) {
                String professor = rs.getString("prNome");
                jCBProfessor.addItem(professor);
            }
            st.close();
            rs.close();
            System.out.println("Professores adicionados com sucesso.");

        } catch (SQLException ex) {
            System.err.println("Erro ao popular professores: " + ex.toString());
        }
    }

    private void jBListarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBListarActionPerformed
        DefaultTableModel modelo = (DefaultTableModel) jTableLista.getModel();
        while (modelo.getRowCount() > 0) {
            modelo.removeRow(0);
        }

        ArrayList<Docentes> al = this.listagemParaTabela();
        adicionarNaTabela(al);
    }//GEN-LAST:event_jBListarActionPerformed

    public void adicionarNaTabela(ArrayList<Docentes> al) {
        DefaultTableModel modelo = (DefaultTableModel) jTableLista.getModel();
        // percorrendo a lista de contatos
        for (Docentes docentes : al) {
            String vetor[] = new String[2];
            vetor[0] = Long.toString(docentes.getId());
            vetor[1] = docentes.getNome();

            //adicionando na tabela
            modelo.addRow(vetor);
        }
    }

    public ArrayList<Docentes> listagemParaTabela() {
        ArrayList<Docentes> lista = new ArrayList<Docentes>();
        String sql = "SELECT * FROM professores";
        try {
            PreparedStatement instrucao = conexao.prepareStatement(sql);
            // executando a instrução
            ResultSet rs = instrucao.executeQuery();
            // percorrendo a lista obtida do banco

            while (rs.next()) {
                Docentes pessoa = new Docentes();
                pessoa.setId(new Long(rs.getInt("prID")));
                pessoa.setNome(rs.getString("prNome"));
                pessoa.setLogin(rs.getString("prLogin"));
                pessoa.setSenha(new Long(rs.getString("prSenha")));
                // adicionando no ArrayList
                lista.add(pessoa);
            }
            // fechando
            instrucao.close();
        } catch (SQLException ex) {
            System.err.println("Erro na listagem de contatos: " + ex.toString());
        }
        return lista;
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jBExcluir;
    private javax.swing.JButton jBListar;
    private javax.swing.JComboBox jCBProfessor;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTableLista;
    // End of variables declaration//GEN-END:variables
}
