package interfaces;

import java.sql.Connection;
import java.util.Date;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFormattedTextField;
import javax.swing.JOptionPane;
import util.bd.CalendarComboBox;
import util.bd.ConexaoBD;
import java.text.*;

public class MenuPr extends javax.swing.JFrame {

    private Connection conexao;
    private String login;
    private Date data;

    public MenuPr(String login) {
        initComponents();
        this.login = login;
        this.popularTurmas();
        this.setLocationRelativeTo(null);

    }

    public void popularTurmas() {
        conexao = new ConexaoBD().obterConexao();
        jCBDisciplina.removeAllItems();
        jCBData.removeAllItems();
        jCBDisciplina.addItem("Selecione uma disciplina.");
        String sql = "select tu.tuID, di.diNome, pr.prNome from turma tu, "
                + "disciplinas di, professores pr where tu.tuDisciplina = di.diID and "
                + "pr.prID = tu.tuProfessor and pr.prLogin = ?";
        try {
            PreparedStatement st = conexao.prepareStatement(sql);
            st.setString(1, this.login);
            ResultSet rs = st.executeQuery();

            while (rs.next() == true) {
                String disciplina = rs.getString("diNome");
                jCBDisciplina.addItem(disciplina);

            }
            st.close();
            rs.close();
            System.out.println("Diciplinas populadas com sucesso!");

        } catch (SQLException ex) {
            System.err.println("Erro ao popular disciplinas: " + ex.toString());
        }
        try {
            conexao.close();
        } catch (SQLException ex) {
            System.err.println("Erro ao fechar conexão: " + ex.toString());
        }

    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jBConceito = new javax.swing.JButton();
        jCBDisciplina = new javax.swing.JComboBox();
        jBAlterarSenha = new javax.swing.JButton();
        jBFreq = new javax.swing.JButton();
        jCBData = new CalendarComboBox(true);
        jBRelatorios = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jBConceito.setText("Conceitos");
        jBConceito.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jBConceitoMouseClicked(evt);
            }
        });
        jBConceito.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBConceitoActionPerformed(evt);
            }
        });

        jCBDisciplina.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        jBAlterarSenha.setText("Alterar senha");
        jBAlterarSenha.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBAlterarSenhaActionPerformed(evt);
            }
        });

        jBFreq.setText("Frequência");
        jBFreq.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBFreqActionPerformed(evt);
            }
        });

        jBRelatorios.setText("Relatórios");
        jBRelatorios.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jBRelatoriosActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jCBDisciplina, 0, 231, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(62, 62, 62)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(jBConceito, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jBFreq, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 111, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jBAlterarSenha, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jBRelatorios, javax.swing.GroupLayout.Alignment.LEADING)))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jCBData, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jCBData, jCBDisciplina});

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jBAlterarSenha, jBConceito, jBFreq, jBRelatorios});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jCBDisciplina, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jCBData, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jBFreq)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jBConceito)
                .addGap(9, 9, 9)
                .addComponent(jBRelatorios)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jBAlterarSenha)
                .addContainerGap(44, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jBAlterarSenhaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBAlterarSenhaActionPerformed
        String senha1 = JOptionPane.showInputDialog("Digite a nova senha:");
        String senha2 = JOptionPane.showInputDialog("Digite novamente a nova senha:");
        System.out.println("" + senha1 + "\n" + senha2);
        if (senha1 == null) {
            System.out.println("Ok.");
        } else {
            if (senha1 == null ? senha2 == null : senha1.equals(senha2)) {
                String sql = "UPDATE professores SET adSenha = ? WHERE adLogin = ?;";
                conexao = new ConexaoBD().obterConexao();
                try {

                    PreparedStatement st = conexao.prepareStatement(sql);
                    st.setInt(1, Integer.parseInt(senha1));
                    st.setString(2, this.login);
                    // executando
                    st.execute();

                    // fechando a instrucao
                    st.close();
                    conexao.close();

                } catch (SQLException ex) {
                    System.err.println("Erro ao inserir2: " + ex.toString());
                }
                JOptionPane.showMessageDialog(this, "Senha alterada com sucesso!");
            } else {
                JOptionPane.showMessageDialog(this, "Senhas diferentes");
            }
        }


    }//GEN-LAST:event_jBAlterarSenhaActionPerformed

    private void jBFreqActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBFreqActionPerformed
        String disciplina = (String) jCBDisciplina.getSelectedItem();
        String data = (String) jCBData.getSelectedItem();
        System.out.println("dia: " + data);
        DateFormat df = new SimpleDateFormat("dd/MM/yyyy");
        df.setLenient(false);

        Date date = null;
        try {
            date = df.parse(data);
        } catch (ParseException ex) {
            Logger.getLogger(MenuPr.class.getName()).log(Level.SEVERE, null, ex);
        }
        CadastroFrequencia cdf = new CadastroFrequencia(this, true, disciplina, date);
        System.out.println("Abrindo módulo de cadastro de frequencia");
        boolean estado = cdf.isVisible();
        if (estado == true) {
            JOptionPane.showMessageDialog(this, "Módulo já está ativo.");
        } else {
            cdf.setVisible(true);
        }

    }//GEN-LAST:event_jBFreqActionPerformed

    private void jBConceitoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBConceitoActionPerformed
        System.out.println("ALO MUNDO CRUEL");
        String disciplina = (String) jCBDisciplina.getSelectedItem();
        CadastroConceitos cco = new CadastroConceitos(this, true, disciplina);
        System.out.println("Abrindo módulo de cadastro de conceitos");
        boolean estado = cco.isVisible();
        if (estado == true) {
            JOptionPane.showMessageDialog(this, "Módulo já está ativo.");
        } else {
            cco.setVisible(true);
        }
    }//GEN-LAST:event_jBConceitoActionPerformed

    private void jBConceitoMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jBConceitoMouseClicked
        // TODO add your handling code here:
    }//GEN-LAST:event_jBConceitoMouseClicked

    private void jBRelatoriosActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jBRelatoriosActionPerformed
        RelatoriosPr rpr = new RelatoriosPr(this, true);
        System.out.println("Abrindo módulo de relatórios");
        boolean estado = rpr.isVisible();
        if (estado == true) {
            JOptionPane.showMessageDialog(this, "Módulo já está ativo.");
        } else {
            rpr.setVisible(true);
        }
    }//GEN-LAST:event_jBRelatoriosActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jBAlterarSenha;
    private javax.swing.JButton jBConceito;
    private javax.swing.JButton jBFreq;
    private javax.swing.JButton jBRelatorios;
    private javax.swing.JComboBox jCBData;
    private javax.swing.JComboBox jCBDisciplina;
    // End of variables declaration//GEN-END:variables
}
